
; demo.asm

; part of the pfgen distribution

; by B. Watson <atari@hardcoders.org>

; this program makes use of the playfld.inc generated by
; pfgen.pl to draw the playfield generated from the ASCII
; art files...

; Just draws a background, in single-line high resolution
; and rotates the colors somewhat

; Tested on z26 v1.46 on a windows machine
; Tested on xstella 1.1 on a linux machine
; *Not* tested on a real Atari (yet)

 processor 6502
 include "vcs.h"
 org $F000

framectr = $80

 sei
 cld
 ldx #$ff
 txs
 lda #0
iloop
 sta 0,x
 bne iloop

main_loop
 lda #2
 sta VSYNC ; start blanking
 sta WSYNC
 sta WSYNC
 lda #44
 sta TIM64T ; go ahead & set timer
 lda #0
 sta WSYNC
 sta VSYNC ; 3 WSYNC's, then turn off VSYNC

 inc framectr ; rotate color every other frame
 lda framectr
 lsr
 sta COLUPF

wait_timer
 lda INTIM
 bne wait_timer ; busy-wait for timer to expire
 sta WSYNC

kernel
 sta VBLANK ; let there be graphics!
 ldy #191-pf_bytes ; single (high) resolution, 192 scanlines


blank_top
 sta WSYNC
 dey
 bpl blank_top

 ldy #pf_bytes
draw_pf
 sta WSYNC
 lda left_pf0,y
 sta PF0
 lda left_pf1,y
 sta PF1
 lda left_pf2,y
 sta PF2 
 lda right_pf1,y
 ldx right_pf2,y
 nop
 nop
 nop
 nop
 sta PF1
 lda right_pf0,y
 sta PF0
 stx PF2
 dey
 bne draw_pf

 sta WSYNC ; finish last scanline

 sty COLUPF ; blank playfiels
 sty PF0
 sty PF1
 sty PF2

 ldx #30
overscan
 sta WSYNC
 dex
 bne overscan

 jmp main_loop

; we need to start the included data at a page boundary.
; if we do, pfgen.pl's output keep us from ever needing to
; cross a page boundary with indexed,y (or x) mode.
 org $F800

 include "playfld.inc"

 org $FFFC
 word $F000
 word $F000


